/* 1 sec 35 cm

*/
#include <Servo.h>

int trigger_findBeer = 3;
int echo_findBeer = 2;

int motor_speed = 150;

//WINDE PINS
int w_a = 4;
int w_b = 5;
int w_pwm = 6;

//RECHTER MOTOR PINS
int r_a = 8;
int r_b = 7;
int r_pwm = 9;

//LINKER MOTOR PINS
int l_a = A3;
int l_b = A2;
int l_pwm = 12;

int uSpeed = 150;

int frontDist = 0;

boolean debug = true;

//StabiMotor
int stabipwm = 10;
int stabi = A5;
int stabiinv = A4;

//BIER SPERRE
Servo beerBarrier;
int barrierPin = A0;

void setup() {
  Serial.begin(9600);

  pinMode(trigger_findBeer, OUTPUT);
  digitalWrite(trigger_findBeer, LOW);
  pinMode(echo_findBeer, INPUT);

  pinMode(w_a, OUTPUT);
  pinMode(w_b, OUTPUT);
  pinMode(w_pwm, OUTPUT);

  pinMode(r_a, OUTPUT);
  pinMode(r_b, OUTPUT);
  pinMode(r_pwm, OUTPUT);

  pinMode(l_a, OUTPUT);
  pinMode(l_b, OUTPUT);
  pinMode(l_pwm, OUTPUT);

  pinMode(stabipwm, OUTPUT);
  pinMode(stabi, OUTPUT);
  pinMode(stabiinv, OUTPUT);

  beerBarrier.attach(barrierPin);
  beerBarrier.write(0);
}

void loop() {
  delay(3000);
  if ( debug )  {
    while ( Serial.available())  {

      char user_in = Serial.read();

      if ( user_in == '1')  {
        windeAbrollen();
      }
      if ( user_in == '2')  {
        windeAufrollen();
      }
      if ( user_in == '3')  {
        windeStop();
      }
      if ( user_in == '4')  {
        Serial.println("Abstand: " + String(getFrontDist()));
      }
      if ( user_in == '5')  {
        leftGo();
      }
      if ( user_in == '6')  {
        leftStop();
      }
      if ( user_in == '7')  {
        rightGo();
      }
      if ( user_in == '8' ) {
        rightStop();
      }
      if ( user_in == '9' ) {
        stepForward();
      }
      if ( user_in == 'f' )  {
        forwardGo();
      }
      if ( user_in == 'g' )  {
        forwardStop();
      }
      if ( user_in == 'h' ) {
        findBeer();
      }
      if ( user_in == 'j' ) {
        driveToBeer();
      }
      if ( user_in == 'k' ) {
        openBeer();
      }
      if ( user_in == 'l')  {
        stabiForward();
      }
      if ( user_in == 'm')  {
        stabiStop();
      }
      if ( user_in == 'p')  {
        stabiBackwards();
      }
      if ( user_in == 'n')  {
        saveBeer();
        delay(1000);
        freeBeer();
      }
      if ( user_in == 'o')  {
        freeBeer();
      }
    }

  } else {
    Serial.println("Öffne Bier");
    debug = !debug;
  }
  /*
    left_Stepper.step(stepper_velocity);
    right_Stepper.step(-stepper_velocity);
  */

  //checkEdges();
}

void stabiForward()  {
  Serial.println("STABI START");
  digitalWrite(stabi, HIGH);
  digitalWrite(stabiinv, LOW);
  analogWrite(stabipwm, 100);
}

void stabiBackwards() {
  Serial.println("STABI BACKWARDS");
  digitalWrite(stabi, HIGH);
  digitalWrite(stabiinv, HIGH);
  analogWrite(stabipwm, 100);
}

void stabiStop()  {
  Serial.println("STABI STOP");
  digitalWrite(stabi, LOW);
  digitalWrite(stabiinv, LOW);
}

void openBeer() {
  saveBeer();
   stabiForward();
  delay(1000);
  //stabiForward();
  windeAufrollen();
  delay(2500);
  stabiStop();
  delay(3500);
  windeStop();
  delay(1000);
  windeAbrollen();
  stabiBackwards();
  delay(5000);
  windeStop();
  //stabiStop();
  delay(1000);
  stabiStop();
  freeBeer();
}

void servoPressure()  {
  for ( int i = 120 ; i <= 150 ; i++ )  {
    
  }
}
void saveBeer() {
  beerBarrier.write(0);
  Serial.println("ZERO");
  delay(1000);
  for ( int i = 0 ; i <= 120 ; i ++ )  {
    beerBarrier.write(i);
    Serial.println(i);
    delay(10);
  }
}

void freeBeer() {
  for ( int i = 120 ; i >= 0; i--) {
    beerBarrier.write(i);
    delay(10);
  }
  beerBarrier.write(0);
  digitalWrite(barrierPin, LOW);
  Serial.println("FREE");
}

void stepForward() {
  rightGo();
  leftGo();
  delay(50);
  rightStop();
  leftStop();
}

void forwardGo()  {
  rightGo();
  leftGo();
}

void forwardStop()  {
  rightStop();
  leftStop();
}

void stepRight()  {
  rightGo();
  delay(100);
  rightStop();
}

void stepBackwards(int i)  {
  digitalWrite(r_a, HIGH);
  digitalWrite(r_b, LOW);
  analogWrite(r_pwm, uSpeed);

  digitalWrite(l_a, HIGH);
  digitalWrite(l_b, LOW);
  analogWrite(l_pwm, uSpeed);
  delay(i);
  rightStop();
  leftStop();
}

void stepLeft() {
  leftGo();
  delay(25);
  leftStop();
}

void findBeer() {
  int frontDist_ = 1000;
  int frontDist2_ = 1000;
  int count = 0;

  digitalWrite(r_a, HIGH);
  digitalWrite(r_b, LOW);
  analogWrite(r_pwm, 70);
  while (true) {
    //stepLeft();
    frontDist_ = getFrontDist();
    //frontDist2_ = getFrontDist();
    if ( frontDist_ <= 150  )  {
      Serial.println("Abstand: " + String(frontDist_));
      Serial.println("Gefunden");
      frontDist = frontDist_;
      break;
    }
    if (frontDist_ < 3000) Serial.println("Abstand: " + String(frontDist_));
    count++;

    /*if ( count >= 100 )  {
      Serial.println("Time out");
      break;
      }*/
  }
  rightStop();
  leftStop();
  move();
  delay(1000);
}

boolean turn(int i)  {
  Serial.println("TURN " + String(i));
  if ( i == 0)  {
    digitalWrite(r_a, LOW);
    digitalWrite(r_a, HIGH);
  } else  {
    digitalWrite(r_a, LOW);
    digitalWrite(r_b, HIGH);
  }
  analogWrite(r_pwm, 70);
  int dist = 40;
  int x = 200;
  while ( x >= 0 )  {
    dist = getFrontDist();
    x--;
    Serial.println(dist);
    if ( dist < 40 )  {
      rightStop();
      return true;
    }
  }
  rightStop();
  return false;
}

void driveToBeer()  {
  int dist = 20;
  int uspeed = 70;

  Serial.println("DRIVE TO BEER");
  digitalWrite(r_a, LOW);
  digitalWrite(r_b, HIGH);
  analogWrite(r_pwm, uspeed);

  digitalWrite(l_a, LOW);
  digitalWrite(l_b, HIGH);
  analogWrite(l_pwm, uspeed);

  while ( dist > 2 ) {
    dist = getFrontDist();
    Serial.println(dist);
    analogWrite(r_pwm, uspeed);
    analogWrite(l_pwm, uspeed);
  }
  rightStop();
  leftStop();
}

void move() {
  Serial.println("MOVE");
  int steps;
  if ( frontDist >= 40 )  {
    steps = frontDist / 40;
  }
  else steps = 2;
  int i = 0;
  while ( i < steps * 2 ) {
    forwardGo();
    delay(500);
    forwardStop();
    //if ( i % 2 == 0  && frontDist > 80 ) stepRight();
    i++;
  }
  if ( turn(0) )  {
    float dist = getFrontDist();
    Serial.println("TURN 0 " + String(dist));
    if ( dist < 40 )  {
      float t = dist / 35;
      t = t * 1000;
      forwardGo();
      analogWrite(r_pwm, 70);
      analogWrite(l_pwm, 70);
      delay(t);
      forwardStop();
    }
    return;
  }

  turn(1);
  stepBackwards(200);
  if ( turn(1) )  {
    rightGo();
    delay(25);
    rightStop();
    float dist = getFrontDist();
    if ( dist < 40 )  {
      double t = dist / 40;
      t *= 1000;

      Serial.println("TURN 1 " + String(dist) + " " + String(t));
      forwardGo();
      
      analogWrite(r_pwm, 70);
      analogWrite(l_pwm, 70);
      delay(t/2);
      analogWrite(r_pwm, 50);
      analogWrite(l_pwm, 50);
      delay(t/2 + 100);
      forwardStop();
    }
    //driveToBeer();
    return;
  }
  // ELSE FINDET KEIN BIER
}

void rightGo()  {
  digitalWrite(r_a, LOW);
  digitalWrite(r_b, HIGH);
  analogWrite(r_pwm, uSpeed);
}

void windeAbrollen()  {
  digitalWrite(w_a, LOW);
  digitalWrite(w_b, HIGH);
  analogWrite(w_pwm, uSpeed);
  Serial.println("WINDE MOVE");
}

void windeAufrollen() {
  digitalWrite(w_a, HIGH);
  digitalWrite(w_b, LOW);
  analogWrite(w_pwm, uSpeed);
  Serial.println("WINDE AUFROLLEN");
}

void windeStop()  {
  digitalWrite(w_a, LOW);
  digitalWrite(w_b, LOW);
  Serial.println("WINDE STOP");
}

void rightStop()  {
  digitalWrite(r_a, LOW);
  digitalWrite(r_b, LOW);
}

void leftGo() {
  digitalWrite(l_a, LOW);
  digitalWrite(l_b, HIGH);
  analogWrite(l_pwm, uSpeed);
}

void leftStop() {
  digitalWrite(l_a, LOW);
  digitalWrite(l_b, LOW);
}

int getFrontDist()  {
  noInterrupts();
  digitalWrite(trigger_findBeer, HIGH);
  delayMicroseconds(10);
  digitalWrite(trigger_findBeer, LOW);
  long Dauer = pulseIn(echo_findBeer, HIGH);
  interrupts();
  long Abstand = Dauer / 58.2;
  return Abstand;
}
